ruby-indent-beg-re の値が壊れている
Priority: Normal   

Assignee: mrkn (Kenta Murata)   

Target version: 1.9.3   

ruby -v: trunk Backport:  

Description

vim-ruby の indent/ruby.vim を修正しようと思い ruby-mode.el を読んでいたところ

ruby-indent-beg-re の値が壊れているような気がしたので報告します。

r19205 で regexp-opt を使って正規表現を最適化するよう改善されていますが、

そのときに \| が抜けてしまっています。

r19204 の 場合:

"\(\s *\(class\|module\|def\)\)\|if\|unless\|case\|while\|until\|for\|begin"

r19205 の場合:

"\(\s *\(class\|def\|module\)\)\(?:begin\|case\|for\|if\|un\(?:less\|til\)\|while\)"

このように class, def, module を囲む括弧の直後にあった \| が落ちています。

それでも、なぜか適切にインデントできていて不思議だったので少しだけ調査してみました。

r19205 以降では、ruby-beginning-of-indent が classif や defbegin のような不適切な語をインデントの開始として

判断してしまいますが、このような語が存在しない場合はバッファの先頭まで戻っていました。

ですから、以下のパッチを当ててこの間違いを修正すると、長いファイルのインデント計算が

若干高速化されるかもしれません。

diff --git a/misc/ruby-mode.el b/misc/ruby-mode.el

index c799d8c..9023b77 100644

--- a/misc/ruby-mode.el

+++ b/misc/ruby-mode.el

@@ -72,7 +72,7 @@

"Regexp to match")

(defconst ruby-indent-beg-re

(concat "\(\s *" (regexp-opt '("class" "module" "def") t) "\)"

(concat "\(\s *" (regexp-opt '("class" "module" "def") t) "\)\|"

(regexp-opt '("if" "unless" "case" "while" "until" "for" "begin")))

"Regexp to match where the indentation gets deeper.")

Associated revisions

Revision be5e1770 - 06/30/2011 02:54 PM - Kenta Murata 

misc/ruby-mode.el (ruby-indent-beg-re): Fix broken regular

expression.  Fixes #4546

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32338 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/01/2011 10:08 AM - mrkn (Kenta Murata)

=begin

新しい Redmine に慣れてなくて、patch が崩れてしまいました。

以下に再掲します。

diff --git a/misc/ruby-mode.el b/misc/ruby-mode.el

index c799d8c..9023b77 100644
--- a/misc/ruby-mode.el

+++ b/misc/ruby-mode.el

@@ -72,7 +72,7 @@

"Regexp to match")

(defconst ruby-indent-beg-re

(concat "\(\s *" (regexp-opt '("class" "module" "def") t) "\)"

(concat "\(\s *" (regexp-opt '("class" "module" "def") t) "\)\|"

(regexp-opt '("if" "unless" "case" "while" "until" "for" "begin")))

"Regexp to match where the indentation gets deeper.")

=end

#2 - 06/26/2011 06:46 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

#3 - 06/26/2011 11:13 PM - nahi (Hiroshi Nakamura)

- Target version changed from 2.0.0 to 1.9.3

#4 - 06/30/2011 08:27 PM - nobu (Nobuyoshi Nakada)

- Assignee changed from nobu (Nobuyoshi Nakada) to mrkn (Kenta Murata)

いれといてください。

#5 - 06/30/2011 11:54 PM - mrkn (Kenta Murata)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r32338.

Kenta, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.
